#!/bin/bash
#
#                           Ezanvakti YAD Arayüz 1 Bileşeni 2.1
#
#
#set -x

. /usr/lib/ezanvakti/temel_islevler.bash
. /usr/lib/ezanvakti/arayuz_temel.bash

# Yalnızca bir arayüz örneği çalışması için
# pid denetimi yapılsın.
arayuz_pid_denetle 1

bilesen_yukle oynatici_yonetici
bilesen_yukle hicri

elx=''
for ((i=1; i<=ARAYUZ_CIZGI_UZUNLUGU; i++))
do
  elx+="${ARAYUZ_CIZGI_SIMGESI}"
done

arayuz() {
  local strng donus str str2 sure sure_sifirli oynatici_ileti secim_basligi
  g_vakitleri_al; g_gun_animsat

strng=$(yad --form --text "$(printf "${GELISMIS_ARAYUZ_BICIMI}" \
  "<span foreground=\'${ARAYUZ_TARIH_SAAT_RENGI}\'>$(date +%d.%m.%Y) \($(hicri_tarih_al)\)</span>" \
  "<span foreground=\'${ARAYUZ_TARIH_SAAT_RENGI}\'>$(date +%H:%M:%S)</span>" \
  "<span foreground=\'${ARAYUZ_KONUM_RENGI}\'>${ILCE} / ${ULKE}</span>" \
  "<span foreground=\'${ARAYUZ_CIZGI_RENGI}\'>${elx}</span>" \
  "<span foreground=\'${ARAYUZ_SIMDIKI_VAKIT_RENGI}\'>${vakit_bilgisi}${ozel_ileti}</span>" \
  "<span foreground=\'${ARAYUZ_CIZGI_RENGI}\'>${elx}</span>" "$(g_vakitleri_yaz)" \
  "<span foreground=\'${ARAYUZ_KALAN_SURE_RENGI}\'>${v_ileti}</span>" \
  "<span foreground=\'${ARAYUZ_KALAN_SURE_RENGI}\'>${v_kalan}</span>")" \
--field="<span foreground=\'${ARAYUZ_SECKE_ADLARI_RENGI}\'>Ezanlar</span>:CB" \
'!Sabah!Öğle!İkindi!Akşam!Yatsı!Sela' \
--field="<span foreground=\'${ARAYUZ_SECKE_ADLARI_RENGI}\'>Sureler</span>:CB" \
"!000-Özel Pencere$sure_listesi" \
--field="<span foreground=\'${ARAYUZ_SECKE_ADLARI_RENGI}\'>Seçimler</span>:CB" \
${secim_listesi} \
--field="<span foreground=\'${ARAYUZ_SECKE_ADLARI_RENGI}\'>Başlatıcı</span>:CE" \
"${tamamlama_listesi}" --button='yad-ok:150' --button="yad-close:121" \
--image=${AD} --window-icon=${AD} --title "${AD^}" --center --fixed)

donus=$(echo $?)

declare -x $(echo "$strng" | sed 's:|: :g' | gawk '{print "str="$1 "\nstr2="$2}')

[[ -n $str2 ]] && arayuz

if (( donus == 150 ))
then
    if [[ $str = Sabah ]]
    then
        oynatici_ileti=" Sabah ezanı dinletiliyor\n\n Okuyan : ${EZAN_OKUYAN}"
        pencere_bilgi "${SABAH_EZANI}" & oynatici_calistir "${SABAH_EZANI}"
        arayuz

    elif [[ $str = Öğle ]]
    then
        oynatici_ileti=" Öğle ezanı dinletiliyor\n\n Okuyan : ${EZAN_OKUYAN}"
        pencere_bilgi "${OGLE_EZANI}" & oynatici_calistir "${OGLE_EZANI}"
        arayuz

    elif [[ $str = İkindi ]]
    then
        oynatici_ileti=" İkindi ezanı dinletiliyor\n\n Okuyan : ${EZAN_OKUYAN}"
        pencere_bilgi "$IKINDI_EZANI" & oynatici_calistir "${IKINDI_EZANI}"
        arayuz

    elif [[ $str = Akşam ]]
    then
        oynatici_ileti=" Akşam ezanı dinletiliyor\n\n Okuyan : ${EZAN_OKUYAN}"
        pencere_bilgi "${AKSAM_EZANI}" & oynatici_calistir "${AKSAM_EZANI}"
        arayuz

    elif [[ $str = Yatsı ]]
    then
        oynatici_ileti=" Yatsı ezanı dinletiliyor\n\n Okuyan : ${EZAN_OKUYAN}"
        pencere_bilgi "${YATSI_EZANI}" & oynatici_calistir "${YATSI_EZANI}"
        arayuz

    elif [[ $str = Sela ]]
    then
        oynatici_ileti=" Cuma selası dinletiliyor\n\n Okuyan : ${SELA_OKUYAN}"
        pencere_bilgi "${CUMA_SELASI}" & oynatici_calistir "${CUMA_SELASI}"
        arayuz

    elif [[ $str = Ayet ]]
    then
        secim_basligi='Günlük Ayet'
        bilesen_yukle ayet_goster
        ayet_goster ucbirim > "${cikti_dosyasi}"
        g_secim_goster; temizlik
        arayuz

    elif [[ $str = Hadis ]]
    then
        secim_basligi='40 Hadis'
        bilesen_yukle bilgi_goster
        hadis_goster ucbirim > "${cikti_dosyasi}"
        g_secim_goster; temizlik
        arayuz

    elif [[ $str = Esma-ül Hüsna ]]
    then
        secim_basligi='Esma-ül Hüsna'
        bilesen_yukle bilgi_goster
        esma_goster ucbirim > "${cikti_dosyasi}"
        g_secim_goster; temizlik
        arayuz

    elif [[ $str = Bilgi ]]
    then
        secim_basligi='Dini Bilgiler'
        bilesen_yukle bilgi_goster
        bilgi_goster ucbirim > "${cikti_dosyasi}"
        g_secim_goster; temizlik
        arayuz

    elif [[ $str = Günlük Vakitler ]]
    then
        secim_basligi='Günlük Vakitler'
        bilesen_yukle vakitleri_goster
        vakitler tum_vakitler > "${cikti_dosyasi}"
        g_secim_goster; temizlik
        arayuz

    elif [[ $str = Aylık Vakitler ]]
    then
        secim_basligi='Aylık Vakitler'
        bilesen_yukle vakitleri_goster
        vakitler aylik > "${cikti_dosyasi}"
        g_secim_goster; temizlik
        arayuz

    elif [[ $str = Haftalık Vakitler ]]
    then
        secim_basligi='Haftalık Vakitler'
        bilesen_yukle vakitleri_goster
        vakitler haftalik > "${cikti_dosyasi}"
        g_secim_goster; temizlik
        arayuz

    elif [[ $str = @(Kerahat Vakitleri|Kerahat) ]]
    then
        secim_basligi='Kerahat Vakitleri'
        bilesen_yukle kerahat
        kerahat_vakitleri ucbirim > "${cikti_dosyasi}"
        g_secim_goster; temizlik
        arayuz

    elif [[ $str = Bayram Namazı Vakitleri ]]
    then
        secim_basligi="$(date +%Y) Bayram namazı vakitleri"
        bilesen_yukle bayram_namazi
        (
          echo 'yad gürültü istiyor'
          bayram_namazi_vakti > "${cikti_dosyasi}"
          echo 'yad gürültü istiyor'
          sed -i 's:.*\.\.\.::g' "${cikti_dosyasi}"
          echo 'yad gürültü istiyor'
        ) | yad --progress --pulsate --auto-close --undecorated \
                --progress-text='Bayram namazı vakitleri alınıyor...' \
                --pulsate --auto-close --width=300 --center --fixed \
                --no-buttons --skip-taskbar
        g_secim_goster; temizlik
        arayuz

    elif [[ $str = Dini Günler ve Geceler ]]
    then
        secim_basligi="$(date +%Y) Dini Günler ve Geceler"
        bilesen_yukle dini_gunler
        gunler > "${cikti_dosyasi}"
        g_secim_goster; temizlik
        arayuz

#     elif [[ $str = Son Cuma Hutbesini indir ]]
#     then
#         bilesen_yukle cuma_hutbesi
#         hutbe_indir
#         arayuz
#
#     elif [[ $str = Cuma Hutbelerini listele ]]
#     then
#         bilesen_yukle cuma_hutbesi
#         hutbe_indir listele
#         arayuz

    elif [[ $str = @(Ayarlar|yapilandirma|Yapılandırma Yöneticisi)  ]]
    then
        bilesen_yukle yapilandirma_yoneticisi
        yapilandirma

    elif [[ $str = özel pencere ]]
    then
        ozel_pencere

    elif [[ $str = güncelle ]]
    then
        bilesen_yukle guncelleyici
        gorsel_guncelleme_yap
        arayuz

    elif [[ $str = güncelle yeni ]]
    then
        bilesen_yukle guncelleyici
        gorsel_guncelleme_yap yenile
        arayuz

    elif [[ $str = @(hakkında|about) ]]
    then
        bilesen_yukle hakkinda
        g_hakkinda; arayuz

    elif [[ $str = arayuz2 ]]
    then
        bilesen_yukle arayuz2
        arayuz2; arayuz

    elif [[ $str = yardım ]]
    then
        bilesen_yukle kullanim
        betik_kullanimi > "${cikti_dosyasi}"
        sed -i '$d' "${cikti_dosyasi}"
        g_secim_goster; temizlik
        arayuz

    elif grep -q [0-9] <<<$str
    then
        sure=$(cut -d'-' -f1 <<<$str)

        if [[ $sure = 000 ]]
        then
            ozel_pencere
        else
            if (( ${#sure} == 1 ))
            then
                sure_sifirli=00$sure
            elif (( ${#sure} == 2 ))
            then
                sure_sifirli=0$sure
            else
                sure_sifirli=$sure
            fi

            if [[ -f "${YEREL_SURE_DIZINI}/$sure_sifirli.mp3" ]]
            then
                okuyan='Yerel Okuyucu'
                dinletilecek_sure="${YEREL_SURE_DIZINI}/$sure_sifirli.mp3"

            elif [[ ${KURAN_OKUYAN} = AlGhamdi ]]
            then
                okuyan='Saad el Ghamdi'
                dinletilecek_sure="http://www.listen2quran.com/listen/${KURAN_OKUYAN}/$sure_sifirli.mp3"
            elif [[ ${KURAN_OKUYAN} = AsShatree ]]
            then
                okuyan='As Shatry'
                dinletilecek_sure="http://www.listen2quran.com/listen/${KURAN_OKUYAN}/$sure_sifirli.mp3"
            elif [[ ${KURAN_OKUYAN} = AlAjmy ]]
            then
                okuyan='Ahmad el Ajmy'
                dinletilecek_sure="http://www.listen2quran.com/listen/${KURAN_OKUYAN}/$sure_sifirli.mp3"
            else
                printf '%s: Desteklenmeyen KURAN_OKUYAN adı: %s\n' "${AD}" "${KURAN_OKUYAN}" >&2
                exit 1
            fi
        fi

        bilesen_yukle kuran_dinletici
        oynatici_ileti="$(gawk -v sira=$sure '{if(NR==sira) print $4;}' < ${VERI_DIZINI}/veriler/sure_bilgisi)"
        oynatici_ileti+=" suresi dinletiliyor\n\n Okuyan : ${okuyan}"

        pencere_bilgi "${dinletilecek_sure}" &
        kuran_dinlet secim $sure
        arayuz

    else
        arayuz
    fi

elif (( donus == 121 ))
then
    exit 0
fi
}; arayuz

# vim: set ft=sh ts=2 sw=2 et:
